<?php //utf-8 marker: äöü 

if (!function_exists('sv') || preg_match('#/plugins/fotopro/index.php#i', $_SERVER['SCRIPT_NAME']))
{
	die('no direct access');
}

/*
============================================================ 
CMSimple Plugin FotoPro
============================================================ 
Version:    FotoPro 5.4
Released:   2023-10
Copyright:  Gert Ebersbach - www.ge-webdesign.de
============================================================ 
License:
- GPL3 or higher
- free for noncommercial websites
- fee required for commercial websites
============================================================ 
utf-8 marker: äöü 
*/

if(!isset($_SESSION)){session_start();}

$_SESSION['fpro_control'] = 'true';

$plugin = 'fotopro';

global $co_author_folder;

if($plugin_cf['fotopro']['activate_lightbox_global'] == 'true' && $plugin_cf['fotopro']['activate_lightbox'] == 'true')
{
	include($pth['folder']['plugins'] . 'fotopro/loadlightbox.php');
}

// DEFINE DATA PATH

if(is_writable('./' . $plugin_cf['fotopro']['data_filepath']))
{
	$fproDataPath = './' . $plugin_cf['fotopro']['data_filepath'];
}
else
{
	$fproDataPath = $pth['folder']['base'] . $plugin_cf['fotopro']['data_filepath'];
}

if(isset($co_author_folder) && is_writable($pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath']))
{
	$fproDataPath = $pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath'];
}



/* 
#####################################
 FUNCTION "FOTOPRO LIGHTBOX GALLERY"
##################################### 
*/

function FotoProLB($fpro_gallery, $fpro_squareWidth='', $fpro_squareMargin='3', $fpro_squareOpacity='0.8')
{
	global $hjs, $cf, $tx, $plugin, $plugin_cf, $plugin_tx, $pth, $sn, $su, $fpro_data, $fproDataPath, $fproPic, $co_author_folder;

	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}


	// define data path

	if(is_writable('./' . $plugin_cf['fotopro']['data_filepath']))
	{
		$fproDataPath = './' . $plugin_cf['fotopro']['data_filepath'];
	}
	else
	{
		$fproDataPath = $pth['folder']['base'] . $plugin_cf['fotopro']['data_filepath'];
	}

	if(isset($co_author_folder) && is_writable($pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath']))
	{
		$fproDataPath = $pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath'];
	}

	if(!is_dir($fproDataPath . $fpro_gallery)) return('<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.6em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">This Gallery<br>not exists</div>');


	// include loadlightbox.php

	if($plugin_cf['fotopro']['activate_lightbox'] == 'true')
	{
		include($pth['folder']['plugins'] . 'fotopro/loadlightbox.php');
	}


	// include data files

	if(file_exists($fproDataPath . $fpro_gallery . '/data.php'))
	{
		include($fproDataPath . $fpro_gallery . '/data.php');
	}

	if(file_exists($fproDataPath . $fpro_gallery . '/design.php'))
	{
		include($fproDataPath . $fpro_gallery . '/design.php');
	}


	// define mediumPics folder

	if($plugin_cf['fotopro']['mediumPics_usage'] == 'true' && is_dir($fproDataPath . $fpro_gallery . '/fpro_mediumPics'))
	{
		$fpro_mediumPicsFolder = 'fpro_mediumPics/';
	}
	else
	{
		$fpro_mediumPicsFolder = '';
	}


	// create images array

	if($fproImagesHandle = opendir($fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder))
	{
		while($fproImage = readdir($fproImagesHandle))
		{
			if(isset($fpro_data[preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage)]['ordernumber']) && preg_match('/.jpg|.jpeg|.png|.webp|.gif/i',$fproImage))
			{
				$fproImages[] = $fpro_data[preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage)]['ordernumber'] . '_fprolb_' . $fproImage;
				if(isset($fproImages)) natcasesort($fproImages);
			}
		}
	} 


	// create thumbs array
	if($handle = opendir($fproDataPath . $fpro_gallery . '/fpro_thumbs/'))
	{
		while($fproThumbLB = readdir($handle))
		{
			if(preg_match('/.jpg|.jpeg|.png|.webp|.gif/i',$fproThumbLB))
			{
				$fproThumbsLB[] = $fproThumbLB;
				sort($fproThumbsLB);
			}
		}
	}

	// Main Container

	$fpro_bg_image = $fproDataPath . $fpro_gallery . '/fpro_bg/background.jpg';

	$fpro_bg_image_dummy = $fproDataPath . $fpro_gallery . '/fpro_bg/bg_dummy.gif';

	if(file_exists($fpro_bg_image))
	{
		$fpro_gallery_output = "\n\n" . '<div class="fproLbMain" style="
	' . $fproLbCssGallery . ' 
	background-image: url(' . $fpro_bg_image . '); 
	background-position : ' . $fproLbBgimageAlign . '; 
	background-repeat : ' . $fproLbBgimageRepeat . ';
	">';
	}
	else
	{
		$fpro_gallery_output = "\n\n" . '<div class="fproLbMain" style="' . $fproLbCssGallery . ' background-image: url(' . $fpro_bg_image_dummy . ');">';
	}

	if($fproLbShowGalleryName == 'true')
	{
		$fpro_gallery_output.= "\n" . '<h4 style="' . $fproLbCssTitle . '">' . $fproLbGalleryName . '</h4>' . "\n";
	}

	if($fproLbShowGalleryDesc == 'true')
	{
		$fpro_gallery_output.= '<p>' . $fproLbGalleryDesc . '</p>' . "\n";
	}

	//Thumbs
	
	$hjs.= '<style>
#fproGalleryLB' . $fpro_gallery . 'Thumbs img:hover {' . $fproLbCssThumbsHover . '}
</style>
';
	
	$fpro_gallery_output.= '<div id="fproGalleryLB' . $fpro_gallery . 'Thumbs">';

	if(empty($fproImages))
	{
		$fpro_gallery_output.= '<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.2em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">No images in this gallery</div>';
	}

	if(empty($fproThumbsLB))
	{
		$fpro_gallery_output.= '<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.2em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">No thumbnails in this gallery</div>';
	}

	if(!empty($fproImages) && !empty($fproThumbsLB))
	{
		foreach($fproImages as $fproImage)
		{
			if($fproLbGalleryDesc == 'thumbs descriptions on') $fpro_gallery_output.= '
<div class="fpro_thumbsDescContainer" style="' . $fproLbGalleryName . '">';
			$fpro_image_name = preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',preg_replace('/.*?_fprolb_/','',$fproImage));
			
			if($fpro_data[$fpro_image_name]["caption"] != '')
			{
				$fpro_gallery_output.= '
<a href="' . $fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder . preg_replace('/.*?_fprolb_/','',$fproImage) . '" class="shutterset_' . $fpro_gallery . '" title="' . $fpro_data[$fpro_image_name]["caption"] . '">';
			}
			else
			{
				$fpro_gallery_output.= '
<a href="' . $fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder . preg_replace('/.*?_fprolb_/','',$fproImage) . '" class="shutterset_' . $fpro_gallery . '" title=" ' . preg_replace('/.*?_fprolb_/','',$fproImage) . '">';
			}
			
			
			if(file_exists($fproDataPath . $fpro_gallery . '/fpro_thumbs/' . preg_replace('/.*?_fprolb_/','',$fproImage)))
			{
				$fproImageSize = getimagesize($fproDataPath . $fpro_gallery . '/fpro_thumbs/' . preg_replace('/.*?_fprolb_/','',$fproImage));
				$w = $fproImageSize[0];
				$h = $fproImageSize[1];
				
				if($h == $w){$fproImageDimensions = 'width: ' . $fpro_squareWidth . 'px; height: ' . $fpro_squareWidth . 'px; margin: 0;';}
				if($h > $w){$fproImageDimensions = 'width: ' . $fpro_squareWidth . 'px; margin: -' . (1-($w/$h)) * 50 . '% auto auto 0;';}
				if($h < $w){$fproImageDimensions = 'height: ' . $fpro_squareWidth . 'px; margin: 0 auto 0 -' . (1-($h/$w)) * 70 . '%;';}
			}

			if($fpro_squareWidth != '')
			{
				$fpro_gallery_output.= '
<div style="background: #222; width: ' . $fpro_squareWidth . 'px; height: ' . $fpro_squareWidth . 'px; float: left; margin: 0 ' . $fpro_squareMargin . 'px ' . $fpro_squareMargin . 'px 0; overflow: hidden;">
<img style="display: block; max-width: 200%; ' . $fproImageDimensions . ' opacity: ' . $fpro_squareOpacity . ';" src="' . $fproDataPath . $fpro_gallery . '/fpro_thumbs/' . preg_replace('/.*?_fprolb_/','',$fproImage) . '" alt="">
</div>
';
			}
			else
			{
				$fpro_gallery_output.= '<img src="' . $fproDataPath . $fpro_gallery . '/fpro_thumbs/' . preg_replace('/.*?_fprolb_/','',$fproImage) . '" 
style="
' . $fproLbCssThumbs . '" 
class="fproLbThumbs" alt="">';
			}
			$fpro_gallery_output.='</a>' . "\n";
			
			if($fproLbGalleryDesc == 'thumbs descriptions on')
			{
				$fpro_gallery_output.= '<p class="fpro_thumbsDesc">' . $fpro_data[preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',preg_replace('/.*?_fprolb_/','',$fproImage))]["caption"] . '&nbsp;</p>';
			}
			
			if($fproLbGalleryDesc == 'thumbs descriptions on') $fpro_gallery_output.= '
</div>
';
		}
	}


	$fpro_gallery_output.= '
	<div style="clear: both;"></div>
	</div>
	<div style="clear: both;"></div>
	</div>
	';

	return $fpro_gallery_output;
}


/* 
#####################################
 FUNCTION "FOTOPRO ONPAGE GALLERY"
##################################### 
*/

function FotoProOP($fpro_gallery, $fproShowThumbs='thumbs', $fproShowDescription='description', $fproShowNavi='navi')
{
	global $hjs, $cf, $tx, $plugin, $plugin_cf, $plugin_tx, $pth, $sn, $su, $fpro_data, $fproDataPath, $fproPic, $co_author_folder, $fproOPimg, $fproGalleryFolder;

	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}

// define data path

	if(is_writable('./' . $plugin_cf['fotopro']['data_filepath']))
	{
		$fproDataPath = './' . $plugin_cf['fotopro']['data_filepath'];
	}
	else
	{
		$fproDataPath = $pth['folder']['base'] . $plugin_cf['fotopro']['data_filepath'];
	}

	if(isset($co_author_folder) && is_writable($pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath']))
	{
		$fproDataPath = $pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath'];
	}

	if(!is_dir($fproDataPath . $fpro_gallery)) return('<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.6em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">This Gallery<br>not exists</div>');


	// include loadlightbox.php

	if($plugin_cf['fotopro']['activate_lightbox'] == 'true')
	{
		include($pth['folder']['plugins'] . 'fotopro/loadlightbox.php');
	}


	// include data files

	if(file_exists($fproDataPath . $fpro_gallery . '/data.php'))
	{
		include($fproDataPath . $fpro_gallery . '/data.php');
	}

	if(file_exists($fproDataPath . $fpro_gallery . '/design.php'))
	{
		include($fproDataPath . $fpro_gallery . '/design.php');
	}


	// define mediumPics folder

	if($plugin_cf['fotopro']['mediumPics_usage'] == 'true' && is_dir($fproDataPath . $fpro_gallery . '/fpro_mediumPics'))
	{
		$fpro_mediumPicsFolder = 'fpro_mediumPics/';
	}
	else
	{
		$fpro_mediumPicsFolder = '';
	}


	// create images array

	if($fproImagesHandle = opendir($fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder))
	{
		while($fproImage = readdir($fproImagesHandle))
		{
			if(preg_match('/.jpg|.jpeg|.png|.webp|.gif/i',$fproImage))
			{
				if(isset($fpro_data[preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage)]['ordernumber']))
					$fproImagesPre[] = $fpro_data[preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage)]['ordernumber'] . '_fprolb_' . $fproImage;
				if(isset($fproImagesPre)) natcasesort($fproImagesPre);
			}
		}
	} 


	// new images array from sorted array

	if(isset($fproImagesPre))
	{
		foreach($fproImagesPre as $fproImage2)
		{
			$fproImages[] = $fproImage2;
		}
	}

	// create thumbs array

	if($handle = opendir($fproDataPath . $fpro_gallery . '/fpro_thumbs/'))
	{
		while($fproThumbLB = readdir($handle))
		{
			if(preg_match('/.jpg|.jpeg|.png|.webp|.gif/i',$fproThumbLB))
			{
				$fproThumbsLB[] = $fproThumbLB;
				sort($fproThumbsLB);
			}
		}
	}

	// Main Container

	$fpro_bg_image = $fproDataPath . $fpro_gallery . '/fpro_bg/background.jpg';

	$fpro_bg_image_dummy = $fproDataPath . $fpro_gallery . '/fpro_bg/bg_dummy.gif';

	$fpro_gallery_output = '
<div id="fproGalleryOP' . $fpro_gallery . '" class="fproGalleryOP"></div>';

	if(file_exists($fpro_bg_image))
	{
		$fpro_gallery_output.= '
<div class="fproLbMain fproGalleryOPmain" style="
' . $fproLbCssGallery . ' 
background-image: url(' . $fpro_bg_image . '); 
background-position : ' . $fproLbBgimageAlign . '; 
background-repeat : ' . $fproLbBgimageRepeat . ';
">';
	}
	else
	{
		$fpro_gallery_output.= "\n\n" . '<div class="fproLbMain fproGalleryOPmain" style="' . $fproLbCssGallery . ' background-image: url(' . $fpro_bg_image_dummy . ');">';
	}

	if(isset($fproLbShowGalleryName) && $fproLbShowGalleryName == 'true')
	{
		$fpro_gallery_output.= "\n" . '<h4 style="' . $fproLbCssTitle . '">' . $fproLbGalleryName . '</h4>' . "\n";
	}

	if(isset($fproLbShowGalleryDesc) && $fproLbShowGalleryDesc == 'true')
	{
		$fpro_gallery_output.= '<p>' . $fproLbGalleryDesc . '</p>' . "\n";
	}


	// prev - next

	if($fproShowNavi == 'navi')
	{
		if(isset($fproImages)) $fproNumberOfImages = count($fproImages);

		if(file_exists($fproDataPath . $fpro_gallery . '/fpro_buttons/prev.gif'))
		{
			$fproOPbuttonsFolder = $fproDataPath . $fpro_gallery . '/fpro_buttons/';
		}
		else
		{
			$fproOPbuttonsFolder = $pth['folder']['plugins'] . 'fotopro/images/';
		}

		if(isset($_REQUEST['fproOPimg' . $fpro_gallery]) && $_REQUEST['fproOPimg' . $fpro_gallery] < ($fproNumberOfImages -1) && $_REQUEST['fproOPimg' . $fpro_gallery] > 0)
		{
			$fpro_gallery_output.= '<p>
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=' . preg_replace('/.*?_fprolb_/','',$_REQUEST['fproOPimg' . $fpro_gallery]-1) . '#fproGalleryOP' . $fpro_gallery . '">
<img src="' . $fproOPbuttonsFolder . 'prev.gif" title="' . $plugin_tx['fotopro']['shutter_prev'] . '" class="fproPrevNextButton" alt="' . $plugin_tx['fotopro']['shutter_prev'] . '">
</a>
<span class="fproOPcounter">' . $plugin_tx['fotopro']['shutter_image'] . ' ' . ($_REQUEST['fproOPimg' . $fpro_gallery]+1) . ' / ' . $fproNumberOfImages . '</span>
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=' . preg_replace('/.*?_fprolb_/','',$_REQUEST['fproOPimg' . $fpro_gallery]+1) . '#fproGalleryOP' . $fpro_gallery . '">
<img src="' . $fproOPbuttonsFolder . 'next.gif" title="' . $plugin_tx['fotopro']['shutter_next'] . '" class="fproPrevNextButton" alt="' . $plugin_tx['fotopro']['shutter_next'] . '">
</a>
</p>
';
		}

		if((!isset($_REQUEST['fproOPimg' . $fpro_gallery]) || $_REQUEST['fproOPimg' . $fpro_gallery] == 0) && isset($fproImagesPre))
		{
			$fpro_gallery_output.= '<p>
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=' . ($fproNumberOfImages-1) . '#fproGalleryOP' . $fpro_gallery . '">
<img src="' . $fproOPbuttonsFolder . 'prev.gif" class="fproPrevNextButton" alt="' . $plugin_tx['fotopro']['shutter_prev'] . '">
</a>
<span class="fproOPcounter">' . $plugin_tx['fotopro']['shutter_image'] . ' ' . 1 . ' / ' . $fproNumberOfImages . '</span>
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=' . 1 . '#fproGalleryOP' . $fpro_gallery . '">
<img src="' . $fproOPbuttonsFolder . 'next.gif" class="fproPrevNextButton" alt="' . $plugin_tx['fotopro']['shutter_next'] . '">
</a>
</p>
';
		}

		if(isset($_REQUEST['fproOPimg' . $fpro_gallery]) && $_REQUEST['fproOPimg' . $fpro_gallery] == ($fproNumberOfImages -1))
		{
			$fpro_gallery_output.= '<p>
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=' . preg_replace('/.*?_fprolb_/','',$_REQUEST['fproOPimg' . $fpro_gallery]-1) . '#fproGalleryOP' . $fpro_gallery . '">
<img src="' . $fproOPbuttonsFolder . 'prev.gif" title="' . $plugin_tx['fotopro']['shutter_prev'] . '" class="fproPrevNextButton" alt="' . $plugin_tx['fotopro']['shutter_prev'] . '">
</a>
<span class="fproOPcounter">' . $plugin_tx['fotopro']['shutter_image'] . ' ' . ($_REQUEST['fproOPimg' . $fpro_gallery]+1) . ' / ' . $fproNumberOfImages . '</span>
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=0#fproGalleryOP' . $fpro_gallery . '">
<img src="' . $fproOPbuttonsFolder . 'next.gif" title="' . $plugin_tx['fotopro']['shutter_next'] . '" class="fproPrevNextButton" alt="' . $plugin_tx['fotopro']['shutter_next'] . '">
</a>
</p>
';
		}
	}


	// Big Image

	if(isset($_REQUEST['fproOPimg' . $fpro_gallery]))
	{
		$fpro_gallery_output.= '<img src="' . $fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder . preg_replace('/.*?_fprolb_/','',$fproImages[$_REQUEST['fproOPimg' . $fpro_gallery]]) . '" style="' . $fproCssImage . '" alt="">';
	}
	else
	{
		if(isset($fproImagesPre)) $fpro_gallery_output.= '<img src="' . $fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder . preg_replace('/.*?_fprolb_/','',$fproImages[0]) . '" style="' . $fproCssImage . '" alt="">';
	}


	// Image Description

	$fpro_gallery_output.= '

<p class="fproOPdescription">';

	if($fproShowDescription == 'description' && isset($fproImagesPre))
	{
		if(!isset($_REQUEST['fproOPimg' . $fpro_gallery]))
		{
			$fproOPimgname = preg_replace('/.*?_fprolb_/','',$fproImages[0]);
			$fproOPDescription = preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproOPimgname);
			
			if($fpro_data[$fproOPDescription]["caption"] != '')
			{
				$fpro_gallery_output_pre = str_replace("\n\r",'<br>',$fpro_data[$fproOPDescription]["caption"]);
				$fpro_gallery_output_pre = str_replace("\r\n",'<br>',$fpro_gallery_output_pre);
				$fpro_gallery_output_pre = str_replace("\n",'<br>',$fpro_gallery_output_pre);
				$fpro_gallery_output_pre = str_replace("\r",'<br>',$fpro_gallery_output_pre);
				
				$fpro_gallery_output.= $fpro_gallery_output_pre;
			}
			else
			{
				$fpro_gallery_output.= $fproOPimgname;
			}
		}
		else
		{
			$fproOPimgname = preg_replace('/.*?_fprolb_/','',$fproImages[$_REQUEST['fproOPimg' . $fpro_gallery]]);
			$fproOPDescription = preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproOPimgname);
			
			if($fpro_data[$fproOPDescription]["caption"] != '')
			{
				$fpro_gallery_output_pre = str_replace("\n\r",'<br>',$fpro_data[$fproOPDescription]["caption"]);
				$fpro_gallery_output_pre = str_replace("\r\n",'<br>',$fpro_gallery_output_pre);
				$fpro_gallery_output_pre = str_replace("\n",'<br>',$fpro_gallery_output_pre);
				$fpro_gallery_output_pre = str_replace("\r",'<br>',$fpro_gallery_output_pre);
				
				$fpro_gallery_output.= $fpro_gallery_output_pre;
			}
			else
			{
				$fpro_gallery_output.= $fproOPimgname;
			}
		}
	}
		$fpro_gallery_output.= '</p>

';


	//Thumbs


	if(empty($fproImages))
	{
		$fpro_gallery_output.= '<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.2em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">No images in this gallery</div>';
	}

	if(empty($fproThumbsLB))
	{
		$fpro_gallery_output.= '<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.2em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">No thumbnails in this gallery</div>';
	}

	
	$hjs.= '<style>
#fproGalleryOP' . $fpro_gallery . 'Thumbs img:hover {' . $fproLbCssThumbsHover . '}
</style>
';
	
	
	if($fproShowThumbs == 'thumbs')
	{
		$fpro_gallery_output.= '<div id="fproGalleryOP' . $fpro_gallery . 'Thumbs">';
		
		if(!empty($fproImages) && !empty($fproThumbsLB))
		{
			foreach($fproImages as $key => $fproImage)
			{
				$fpro_image_name = preg_replace('/.*?_fprolb_|.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage);
				
				if($fpro_data[$fpro_image_name]["caption"] != '')
				{
					$fpro_gallery_output.= '
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=' . $key . '#fproGalleryOP' . $fpro_gallery . '" title="' . $fpro_data[$fpro_image_name]["caption"] . '">';
				}
				else
				{
					$fpro_gallery_output.= '
<a href="?' . $su . '&amp;fproOPimg' . $fpro_gallery . '=' . $key . '#fproGalleryOP' . $fpro_gallery . '" title=" ' . preg_replace('/.*?_fprolb_/','',$fproImage) . '">';
				}

				$fpro_gallery_output.= '
<img src="' . $fproDataPath . $fpro_gallery . '/fpro_thumbs/' . preg_replace('/.*?_fprolb_/','',$fproImage) . '" 
style="
' . $fproLbCssThumbs;

				if(isset($_REQUEST['fproOPimg' . $fpro_gallery]) && $fproImages[$_REQUEST['fproOPimg' . $fpro_gallery]] == $fproImage)
				{
					$fpro_gallery_output.= "\n" . $fproLbCssThumbsActive;
				}

				$fpro_gallery_output.= '" 
class="fproLbThumbs" alt="">
</a>
';
			}
		}
	$fpro_gallery_output.= '</div>';
	}

	$fpro_gallery_output.= '
	<div style="clear: both;"></div>
	</div>
	';

	return $fpro_gallery_output;
}


/* 
#######################################
 FUNCTION "FOTOPRO ONPAGE GALLERY JS"
#######################################
*/

function FotoProOPJS($fpro_gallery, $fproShowDescription='description')
{
	global $hjs, $cf, $tx, $plugin, $plugin_cf, $plugin_tx, $pth, $sn, $su, $fpro_data, $fproDataPath, $fproPic, $co_author_folder, $fproOPimg, $fproGalleryFolder;

	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}

	// define data path

	if(is_writable('./' . $plugin_cf['fotopro']['data_filepath']))
	{
		$fproDataPath = './' . $plugin_cf['fotopro']['data_filepath'];
	}
	else
	{
		$fproDataPath = $pth['folder']['base'] . $plugin_cf['fotopro']['data_filepath'];
	}

	if(isset($co_author_folder) && is_writable($pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath']))
	{
		$fproDataPath = $pth['folder']['base'] . $co_author_folder . $plugin_cf['fotopro']['data_filepath'];
	}

	if(!is_dir($fproDataPath . $fpro_gallery)) return('<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.6em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">This Gallery<br>not exists</div>');


	// include data files

	if(file_exists($fproDataPath . $fpro_gallery . '/data.php'))
	{
		include($fproDataPath . $fpro_gallery . '/data.php');
	}

	if(file_exists($fproDataPath . $fpro_gallery . '/design.php'))
	{
		include($fproDataPath . $fpro_gallery . '/design.php');
	}


	// define mediumPics folder

	if($plugin_cf['fotopro']['mediumPics_usage'] == 'true' && is_dir($fproDataPath . $fpro_gallery . '/fpro_mediumPics'))
	{
		$fpro_mediumPicsFolder = 'fpro_mediumPics/';
	}
	else
	{
		$fpro_mediumPicsFolder = '';
	}


	// create images array

	if($fproImagesHandle = opendir($fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder))
	{
		while($fproImage = readdir($fproImagesHandle))
		{
			if(preg_match('/.jpg|.jpeg|.png|.webp|.gif/i',$fproImage))
			{
				if(isset($fpro_data[preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage)]['ordernumber'])) $fproImagesPre[] = $fpro_data[preg_replace('/.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage)]['ordernumber'] . '_fprolb_' . $fproImage;
				if(isset($fproImagesPre)) natcasesort($fproImagesPre);
			}
		}
	} 


	// new images array from sorted array

	if(isset($fproImagesPre))
	{
		foreach($fproImagesPre as $fproImage2)
		{
			$fproImages[] = $fproImage2;
		}
	}


	// create thumbs array

	if($handle = opendir($fproDataPath . $fpro_gallery . '/fpro_thumbs/'))
	{
		while($fproThumbLB = readdir($handle))
		{
			if(preg_match('/.jpg|.jpeg|.png|.webp|.gif/i',$fproThumbLB))
			{
				$fproThumbsLB[] = $fproThumbLB;
				sort($fproThumbsLB);
			}
		}
	}

	// Main Container

	$fpro_bg_image = $fproDataPath . $fpro_gallery . '/fpro_bg/background.jpg';

	$fpro_bg_image_dummy = $fproDataPath . $fpro_gallery . '/fpro_bg/bg_dummy.gif';

	$fpro_gallery_output = '
<div id="fproGalleryOPJS' . $fpro_gallery . '" class="fproGalleryOP"></div>';
	
	if(file_exists($fpro_bg_image))
	{
		$fpro_gallery_output.= '
<div id="fproGalleryOPJS' . $fpro_gallery . 'Thumbs" class="fproLbMain fproGalleryOPmain" style="
	' . $fproLbCssGallery . ' 
	background-image: url(' . $fpro_bg_image . '); 
	background-position : ' . $fproLbBgimageAlign . '; 
	background-repeat : ' . $fproLbBgimageRepeat . ';
	">';
	}
	else
	{
		$fpro_gallery_output.= '
<div class="fproLbMain fproGalleryOPmain" style="' . $fproLbCssGallery . ' background-image: url(' . $fpro_bg_image_dummy . ');">';
	}
	
	// noscript
	$fpro_gallery_output.= '
<noscript><p style="display: table; background: #900; color: #fff; font-size: 18px; padding: 6px 16px; margin: 16px auto;">Javascript is disabled!</p></noscript>
';

	if(isset($fproLbShowGalleryName) && $fproLbShowGalleryName == 'true')
	{
		$fpro_gallery_output.= "\n" . '<h4 style="' . $fproLbCssTitle . '">' . $fproLbGalleryName . '</h4>' . "\n";
	}

	if(isset($fproLbShowGalleryDesc) && $fproLbShowGalleryDesc == 'true')
	{
		$fpro_gallery_output.= '<p>' . $fproLbGalleryDesc . '</p>' . "\n";
	}


	// Big Image

	if(isset($_REQUEST['fproOPimg' . $fpro_gallery]))
	{
		$fpro_gallery_output.= '<img src="' . $fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder . preg_replace('/.*?_fprolb_/','',$fproImages[$_REQUEST['fproOPimg' . $fpro_gallery]]) . '" id="fproOP_bigImage_' . $fpro_gallery . '" class="fproOP_bigImage" style="' . $fproCssImage . '" alt="">';
	}
	else
	{
		if(isset($fproImagesPre)) $fpro_gallery_output.= '<img src="' . $fproDataPath . $fpro_gallery . '/' . $fpro_mediumPicsFolder . preg_replace('/.*?_fprolb_/','',$fproImages[0]) . '" id="fproOP_bigImage_' . $fpro_gallery . '" class="fproOP_bigImage" style="' . $fproCssImage . '" alt="">';
	}


	// Image Description
	
	if($fproShowDescription == 'description' && isset($fproImagesPre))
	{
		foreach($fproImages as $key => $fproImage)
		{
			$fpro_image_first[] = preg_replace('/.*?_fprolb_|.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage);
			
			if(isset($fpro_data[$fpro_image_first[0]]["caption"]) && $fpro_data[$fpro_image_first[0]]["caption"] != '')
			{
				$fpro_image_desc = $fpro_data[$fpro_image_first[0]]["caption"];
			}
			else
			{
				$fpro_image_desc = preg_replace('/.*?_fprolb_/i','',$fproImages[0]);
			}
		}
		$fpro_gallery_output.= '
<p id="fproOPdescription_' . $fpro_gallery . '" class="fproOPdescription">' . $fpro_image_desc . '</p>';
	}
	else
	{
		$fpro_gallery_output.= '
<p class="fproOPdescription"></p>';
	}


	//Thumbs

	$hjs.= '<style>
#fproGalleryOPJS' . $fpro_gallery . 'Thumbs img:hover {' . $fproLbCssThumbsHover . '}
</style>
';

	$fpro_gallery_output.= '
<div id="fproGalleryOPJS' . $fpro_gallery . 'Thumbs">';
	
	if(empty($fproImages))
	{
		$fpro_gallery_output.= '
<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.2em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">No images in this gallery</div>';
	}

	if(empty($fproThumbsLB))
	{
		$fpro_gallery_output.= '
<div style="display: inline-block; width: 120px; background: #ccc; color: #665; font-family: georgia, serif; font-size: 17px; font-weight: 400; line-height: 1.2em; text-align: center; border: 3px solid #998; padding: 6px 20px; margin: 8px;">No thumbnails in this gallery</div>';
	}

	if(!empty($fproImages) && !empty($fproThumbsLB))
	{
		foreach($fproImages as $key => $fproImage)
		{
			$fpro_image_name = preg_replace('/.*?_fprolb_|.jpg|.jpeg|.png|.webp|.gif/i','',$fproImage);
			$fpro_image_file = preg_replace('/.*?_fprolb_/','',$fproImage);
			$fpro_image_path = $fproDataPath . $fpro_gallery . '/' .  $fpro_mediumPicsFolder . $fpro_image_file;
			if(isset($fpro_data[$fpro_image_name]["caption"]) && $fpro_data[$fpro_image_name]["caption"] != '')
			{
				$fpro_image_thumbdesc = $fpro_data[$fpro_image_name]["caption"];
			}
			else
			{
				$fpro_image_thumbdesc = $fpro_image_file;
			}
			
			$fpro_gallery_output.= '
<a href="#fproGalleryOPJS' . $fpro_gallery . '">';
			
			$fpro_gallery_output.= '
<img onclick="document.getElementById(\'fproOP_bigImage_' . $fpro_gallery . '\').src = \'' . $fpro_image_path . '\'; 
document.getElementById(\'fproOPdescription_' . $fpro_gallery . '\').innerHTML = \'' . $fpro_image_thumbdesc . '\'; 
return false" src="' . $fproDataPath . $fpro_gallery . '/fpro_thumbs/' . $fpro_image_file . '" style="' . $fproLbCssThumbs . '" class="fproLbThumbs" title="' . $fpro_image_thumbdesc . '" alt="' . $fpro_image_thumbdesc . '">';
			
			$fpro_gallery_output.='
</a>
';
		}
	}

	$fpro_gallery_output.= '
	</div>
	<div style="clear: both;"></div>
	</div>
	';

	return $fpro_gallery_output;
}

?>
